{-# LANGUAGE DerivingVia #-}

module Lib
  ( runBothServers,
  )
where

import ClassyPrelude
import Types.AppTypes
import WebServer (runWebServer)
import WebSocket (initMVarState, runWebSocketServer)

runBothServers :: IO ()
runBothServers = do
  connectedClientsState <- initMVarState

  let env =
        Env
          { connectedClientsState = connectedClientsState,
            profile = Dev
          }

  _ <- concurrently (unApp runWebSocketServer env) (unApp runWebServer env)
  return ()
