{-# LANGUAGE DerivingVia #-}

module Types.AppTypes (Env (..), App (..), getConnectedClientState, HasConnectedClientState, App, AppProfile (Prod, Dev)) where

import ClassyPrelude
import Types.ConnectionState (ConnectedClientsState)

data AppProfile = Prod | Dev

data Env = Env
  { connectedClientsState :: ConnectedClientsState,
    profile :: AppProfile
  }

class HasConnectedClientState a where
  getConnectedClientState :: a -> ConnectedClientsState

instance HasConnectedClientState Env where
  getConnectedClientState = connectedClientsState

newtype App env a = App {unApp :: env -> IO a}
  deriving
    ( Functor,
      Applicative,
      Monad,
      MonadReader env,
      MonadIO
    )
    via ReaderT env IO
